# This is auto-generated by Datastar. DO NOT EDIT.
from enum import StrEnum

#region The mode in which a fragment is merged into the DOM.
class FragmentMergeMode(StrEnum):
    # Morphs the fragment into the existing element using idiomorph.
    FragmentMergeModeMorph = "morph"

    # Replaces the inner HTML of the existing element.
    FragmentMergeModeInner = "inner"

    # Replaces the outer HTML of the existing element.
    FragmentMergeModeOuter = "outer"

    # Prepends the fragment to the existing element.
    FragmentMergeModePrepend = "prepend"

    # Appends the fragment to the existing element.
    FragmentMergeModeAppend = "append"

    # Inserts the fragment before the existing element.
    FragmentMergeModeBefore = "before"

    # Inserts the fragment after the existing element.
    FragmentMergeModeAfter = "after"

    # Upserts the attributes of the existing element.
    FragmentMergeModeUpsertAttributes = "upsertAttributes"

#endregion FragmentMergeMode

#region The type protocol on top of SSE which allows for core pushed based communication between the server and the client.
class EventType(StrEnum):
    # An event for merging HTML fragments into the DOM.
    EventTypeMergeFragments = "datastar-merge-fragments"

    # An event for merging signals into the store.
    EventTypeMergeSignals = "datastar-merge-signals"

    # An event for removing HTML fragments from the DOM.
    EventTypeRemoveFragments = "datastar-remove-fragments"

    # An event for removing signals from the store.
    EventTypeRemoveSignals = "datastar-remove-signals"

    # An event for executing <script/> elements in the browser.
    EventTypeExecuteScript = "datastar-execute-script"

#endregion EventType

#endregion Enums

DATASTAR_KEY = "datastar"
VERSION                   = "0.20.1"
VERSION_CLIENT_BYTE_SIZE     = 35789
VERSION_CLIENT_BYTE_SIZE_GZIP = 12568

#region Default durations

# The default duration for settling during merges. Allows for CSS transitions to complete.
DefaultSettleDuration = 300
# The default duration for retrying SSE on connection reset. This is part of the underlying retry mechanism of SSE.
DefaultSseRetryDuration = 1000

#endregion Default durations

#region Default strings

# The default attributes for <script/> element use when executing scripts. It is a set of of key-value pairs delimited by a newline \\n character.
DefaultExecuteScriptAttributes = "type module"

#endregion Default strings

#region Dataline literals
SelectorDatalineLiteral = "selector "
MergeModeDatalineLiteral = "mergeMode "
SettleDurationDatalineLiteral = "settleDuration "
FragmentsDatalineLiteral = "fragments "
UseViewTransitionDatalineLiteral = "useViewTransition "
SignalsDatalineLiteral = "signals "
OnlyIfMissingDatalineLiteral = "onlyIfMissing "
PathsDatalineLiteral = "paths "
ScriptDatalineLiteral = "script "
AttributesDatalineLiteral = "attributes "
AutoRemoveDatalineLiteral = "autoRemove "
#endregion Dataline literals

#region Default booleans

# Should fragments be merged using the ViewTransition API?
DefaultFragmentsUseViewTransitions = False

# Should a given set of signals merge if they are missing from the store?
DefaultMergeSignalsOnlyIfMissing = False

# Should script element remove itself after execution?
DefaultExecuteScriptAutoRemove = True

#endregion Default booleans

#region Enums